require'abstractions.rb'

StartTime = MaxTime = 15*60+1
LightnessTime = 15*60
DarknessTime = 7*60
TimePerKill = 7
RevealTime = 1


use TerranGround,TerranAir,TerranBuildings,TerranAddons,
  ProtossGround,ProtossAir,ProtossBuildings,
  ZergGround,ZergAir,ZergBuildings

section All
hypertriggers

Debug = false #true
DebugVote = false
d = [:observer, :scourge, :valkyrie, :scout, :corsair, :mutalisk, :wraith, :shuttle] if DebugVote

once(loopall{|i| Men[i].at("ground").moveloc("location %d"%i) })

use Civilian=:civ

Slayer = var
Phantom = var
VoteHigh = globalvar
VoteLow = globalvar
trig{
  Ore.set 50
  Slayer.set
  Timer.set 30
  display '                                                             <02>Pass






                                  <02>High                                                  Low


                                                      <04>Resource Vote'
  Civilian.at("center")+1
  :revealer.at("center")+1
  Civilian.invincibility.set
  VoteHigh+20
  VoteLow+20
  
  Custom.leaderboard if Debug
}

if DebugVote
trig(Civilian[Foes]>6){d.each{|u|u.at("center")+1}}
loopall{|i| ptrig(i, d[i-1][All].moveloc("t"), Civilian.move("t"), swait(4)) }
end

#resource vote and intro code #######################################
VoteComplete = switch
GameStart = switch
LowResource = switch
ptrig(GameStart.off?){
  center("center")
  [:drone, :scv, :probe, :buildings, :larva, :overlord].each{|u|u.unselect}
}

trig(firstplayer.on?, VoteHigh<10){ VoteComplete.set }

trig(firstplayer.on?, VoteComplete.off?, VoteLow<10) {
  VoteComplete.set
  LowResource.set
}

trig(firstplayer.on?, VoteComplete.off?, VoteHigh^10, VoteLow^10) {
  VoteComplete.set
  LowResource.randomize
  runall { display("<4>Tie vote, random selection") }
}

ponce {
  VoteHigh|10
  VoteLow|10
  Ore[All]|10 if DebugVote
  Gas[All]|10 if DebugVote
}

ptrig(Civilian.on?) {
  VoteHigh+1
  VoteLow+1
  Ore[All]+1 if DebugVote
  Gas[All]+1 if DebugVote
}

ptrig(Civilian.at("low resource").on?){ VoteLow-2 ; Ore[All]-2 if DebugVote}
ptrig(Civilian.at("high resource").on?){ VoteHigh-2; Gas[All]-2 if DebugVote}
trig(Civilian.at("no vote").on?) { Civilian.kill.clear }

trig(Timer.off?, Civilian.at("high resource").off?, Civilian.at("low resource").off?){
  Civilian.teleport("no vote")
}

DropHackers = switch
PickPhantoms = switch
AddGas = var
AddOre = var
trig(VoteComplete.on?){
  Civilian[All].kill.clear
  :revealer.clear
  swait(12)
  GameStart.set
  Timer.clear
  AnyBuilding.moveloc("t")
  center("t")
  at("no vote")[Neutral].clear
  at("low resource")[Neutral].clear
  at("high resource")[Neutral].clear
  speed = Debug ? 10 : 67
  display "<04>Welcome to <07>Phantom <06>4.2<04>!"
  swait(speed)
  display "<4>In a few moments the <7>phantom <4>will be chosen"
  swait(speed)
	display "<4>The <7>phantom's <4>identity is a mystery"
  swait(speed)
	display "<4>...aside from its abundant <1c>resources <4>and desire to destroy"
  swait(speed)
	display "<4>This bonus is equal to 50% of all <1f>slayer's <4>mining"
  swait(speed)
	display "<4>This is the cover blow timer, <8>kills<4> by anyone make it go back up"
	Timer|StartTime
  swait(speed)
	display "<4>There is temporary <1e>darkness <4>at #{(DarknessTime/60.0).round}:00"
  swait(speed)
  display "<4>Users of known <3>hacks <4>will <3>drop <4>now..."
  DropHackers.set
	#display "<4>This version is in <3>beta"
  swait(speed)
	display "<4>Good luck"
	playwav "CHEW05"
  swait(speed)
	PickPhantoms.set
  AddOre.clear
  AddGas.clear
}

trig(GameStart.on?, LowResource.off?) {
  playwav "piece2"
  setresources 50000
}

trig(GameStart.on?, LowResource.on?){ playwav "steel2" }

#hacker banning code ###################################
def movedworkers?
  [loopall{|i|at("Location %d"%i).off?}]
end

IsHacker=var
trig(VoteComplete.off?, movedworkers?) {
  IsHacker.set
  AnyBuilding.moveloc("t")
  [:drone, :probe, :scv].each{|u| u.teleport("t") }
  Gas+1 if Debug
}

trig(DropHackers.on?, IsHacker.on?) {
  kill.clear
  crash
  defeat
}
  
#phantom selection code ###################################
PhantomChosen = switch
NumPhantoms = globalvar

if Debug
  trig(PhantomChosen.on?) {
    OreAndGas+10000
    :Devouring+20
  }
end

#the custom business is to favor more skilled players, this is ignored for second phantom though
randswitches = (1..3).map{switch}
ptrig(PhantomChosen.off?){ randswitches.map{|s| s.randomize} }
trig(PickPhantoms.off?, movedworkers?, Ore<50, randswitches.map{|i|i.on?}) {
  Custom[All]+1
  Custom|10
}

trig(NumPhantoms.off?, PickPhantoms.on?, Custom.most) {
  Phantom.set
  NumPhantoms+1
  fi {
    Slayer[All] < 7
    PhantomChosen.set
  }
}

trig(NumPhantoms^1, PhantomChosen.off?, Phantom.off?, randswitches.map{|i|i.on?}) {
  Phantom.set
  NumPhantoms+1
  PhantomChosen.set
}

#nested if abstraction would be nice here
trig(Phantom.on?, PhantomChosen.on?, NumPhantoms^1) {
  display "<04>You are the <07>phantom
<08>Kill <1F>everyone"
}
trig(Phantom.on?, PhantomChosen.on?, NumPhantoms^2) {
  display "<04>You are one of two <07>phantoms
<08>Kill all <1F>slayers"
}
BeenPhantom = var
trig(Phantom.on?, PhantomChosen.on?) {
  BeenPhantom.set
  Slayer.clear
  playwav('Zerg\BUGGUY\ZBGWht00', true)
  swait(100)
  display "<4>Don't worry you'll get more gas later (you get half of all <1f>slayers mining)"
}

trig(BeenPhantom.off?, PhantomChosen.on?, NumPhantoms^1) {
  display "<04>You are a <1F>slayer
<04>Kill the <07>phantom"
  playwav("sight3")
}
trig(BeenPhantom.off?, PhantomChosen.on?, NumPhantoms^2) {
  display "<04>You are a <1F>slayer
<04>Kill both <07>phantoms"
  playwav("sight3")
}

#phantom resource bonus code #################################
A=var
B=var
[[Ore,AddOre],[Gas,AddGas]].each{|res,resvar|
  last=var
  binary(res, BeenPhantom.off?, pt) {|x| A+x; B+x }
  ptrig(BeenPhantom.off?) { res.clear }
  binary(last, BeenPhantom.off?, pt, &-B)
  binary(A, BeenPhantom.off?, pt) {|x| res+x; last+x }
  binary(B, BeenPhantom.off?, pt, 64, &+resvar[All])
  binary(resvar, Phantom.on?, Phantom[All]>1, pt, 64, 8) {|x| res+x/4 }
  binary(resvar, Phantom.on?, Phantom[All]<=1, pt, 64, 8) {|x| res+x/2 }
}

#darkness handling #####################################
 if Debug
  ptrig(un("Protoss Probe").deaths.on?) { :probe.deaths.clear; Timer+600}
  loopall{|i|trig(i, alliance[All].set)}
end

GiveVision = var
GiveVisionFrom = [nil]+(1..8).map{var}
DarknessNotify = var
Darkness = switch
Reveal = switch

ptrig(KillsAndRazings>=100) {
  Timer + TimePerKill
  KillsAndRazings - 500
}
ptrig(Timer>MaxTime){ Timer|MaxTime }

ptrig(Timer<DarknessTime, PhantomChosen.on?, Darkness.off?) {
  Darkness.set
  runall {
    display"<04>Darkness sets in"
    playwav"wolf_howl2"
    pt
    fi {
      swait(70)
      display"<03>Lights <04>on at #{(LightnessTime/60.0).round}:00"
    }
  }
}

ptrig(Timer>=LightnessTime, Darkness.on?) {
  Darkness.clear
  runall {
    display"<04>Let there be <17>light"
    playwav"rooster2"
    GiveVision.set
    pt
  }
}

trig(PhantomChosen.on?, Timer<RevealTime) {
  display"<07>Phantom, <04>show yourself"
  playwav"Misc\ZRescue"
  Reveal.set
  swait(12*35)
  Reveal.clear
}

loopall{|i|
  ptrig(i, GiveVision.on?) {
    GiveVisionFrom[i][Allies].set
    GiveVision.clear
  }

  ptrig(Reveal.on?, Phantom[i].on?) { Vision+i }
    
  ptrig(GiveVisionFrom[i].on?) {
    Vision+i
    GiveVisionFrom[i].clear
  }
}

loopall{|i|
  ptrig(i, Darkness.on?) { ([*1..8]-[i]).map{|j|Vision-j} }
}

#end of game handling, elimination notification ############################

trig(AnyBuilding.off?, Slayer.on?) {
  Slayer.clear
  fi{
    Slayer[All].on?
    display "<04>You are <08>dead
<04>That is too bad, but you may still watch"
    give(Neutral)
    playwav 'Terran\Duran\TDnDth00'
    runothers {
      display "<1F>Slayer <04>eliminated"
      playwav 'Misc\Transmission', true
      pt
    }
  }
}

trig(AnyBuilding.off?, Phantom.on?) {
  Phantom.clear
  fi{
    Phantom[All].on?
    display "<04>You <08>died <04>but stay and see if the other <07>phantom <4>can win"
    give(Neutral)
    playwav 'death3'
    runothers {
      display "<07>Phantom <04>1 of 2 eliminated"
      playwav 'death3'
    }
  }
}
#maybe also good to have sound trigger for phantom 1 of 2 leaving

trig(Slayer[All].off?) {
  playwav 'Muahaha'
  fi {
    BeenPhantom.off?
    display'<04>All your base are belong to <07>me'
    kill.clear
  }
  sync {
    BeenPhantom.on?
    display '<04>You have destroyed all <1F>slayers
<04>You truly are the <07>Phantom'
    swait(20)
    victory
  }
}

trig(Phantom[All].off?, PhantomChosen.on?) {
  playwav 'death3'
  fi {
    BeenPhantom.on?
    display'<04>Have a fun time in <17>hell'
    kill.clear
  }
  sync {
    BeenPhantom.off?
    display '<04>Good has prevailed, the <07>phantom <04>is no more!'
    swait(20)
    playwav 'yippie2'
    victory
  }
}